<?php
if( !class_exists('QuoteRotator') ) :

class QuoteRotator
{
	var $tableName;
	var $pluginPath;
	var $currentVersion;
	
	function QuoteRotator()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		
		$this->currentVersion = '0.1';
		$this->tableName = $wpdb->prefix . 'QuoteRotator';
		$this->pluginPath = get_settings('siteurl') . '/wp-content/plugins/flexi-quote-rotator/';
		
		$options = get_option('widgetQuoteRotator');
		$options['version'] = $this->currentVersion;
		update_option('widgetQuoteRotator', $options);
	}
	
	function createDatabaseTable()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		
		$options = array();
		$options['title'] = 'Quote Rotator';
		$options['delay'] = 5;
		$options['fade'] = 2;
		$options['fontsize'] = 12;
		$options['fontunit'] = 'px';
		
		if( !get_option('widgetQuoteRotator') )
		{
			add_option('widgetQuoteRotator', $options);
		}
		
		if( $wpdb->get_var("SHOW TABLES LIKE `" . $this->tableName . "`") != $this->tableName)
		{
			$sql = "CREATE TABLE `" . $wpdb->prefix . "QuoteRotator` (`id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT PRIMARY KEY, `quote` TEXT NULL);";
			//$sql = "CREATE TABLE `" . $this->tableName . "` (`id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT PRIMARY KEY, `quote` TEXT NULL);";
			require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
			dbDelta($sql);
			$options['version'] = $this->currentVersion;
		}
		$sql = "ALTER TABLE `" . $this->tableName . "` ADD `author` VARCHAR(255) NOT NULL AFTER `quote`;";
		$wpdb->query($sql);
		$sql = "RENAME TABLE `wp_QuoteRotator` TO `$this->tableName`;";
		$wpdb->query($sql);
		$sql = "ALTER TABLE `" . $this->tableName . "` CHANGE `quote` `quote` TEXT NULL;";
		$wpdb->query($sql);
		update_option('widgetQuoteRotator', $options);
		delete_option('widgetizeQuoteRotator');		
	}
	
	function deleteDatabaseTable()
	{
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
		delete_option('widgetQuoteRotator');
		//global $wpdb;
		
		//$sql = "DROP TABLE IF EXISTS " . $this->tableName . ";";	
		//$wpdb->query($sql);
	}
	
	function addHeaderContent()
	{
		global $wpdb;
		
		if( !function_exists('get_option') )
		{
			require_once('../../../wp-config.php');
		}
      
      $delay = get_option('fqr_delay');
      if (!isset($delay) || $delay == "") $delay = 5;
      $fade = get_option('fqr_fade');
      if (!isset($fade) || $fade == "") $fade = 2;
      $random = get_option('fqr_random');
      if (!isset($random) || $random == "") $random = 0;
		
		if($random)
			$sql = "SELECT * FROM " . $this->tableName . " ORDER BY RAND(".time().")";
		else
			$sql = "SELECT * FROM " . $this->tableName . " ORDER BY id";
		$results = $wpdb->get_results($sql);
		
      $stylesdir	= 'wp-content/plugins/flexi-quote-rotator/styles/';
		$cssfile = get_option('fqr_stylesheet');
      if (file_exists(ABSPATH . $stylesdir . $cssfile)) {
         echo "<link rel=\"stylesheet\" href=\"" . get_settings('siteurl') . '/' . $stylesdir . $cssfile ."\" type=\"text/css\" media=\"screen\" />\n";
      }
      echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/prototype.js\" type=\"text/javascript\"></script>\n";
		echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/scriptaculous.js\" type=\"text/javascript\"></script>\n";
		echo "<script src=\"" . get_settings('siteurl') . "/wp-includes/js/scriptaculous/effects.js\" type=\"text/javascript\"></script>\n";
		
		echo "<script type=\"text/javascript\">\n";
		echo "quoteRotator = {\n";
		echo "\"i\":1,\n";
		echo "\"quotes\" : [\n";
		$i=0;
		foreach($results as $result){
			echo "\"$result->quote";
			if($result->author != '')
				echo " <span id='quoteauthor'>$result->author</span>";
			echo "\",\n";
			$i++;
		}
		echo "],\n";
		echo "\"num_quotes\" : $i,\n";
		echo "\"opac\":100,\n";
		echo "\"showFading\":1,\n";
      echo "\"fadeDuration\":" . $fade . ",\n";
		echo "\"delay\":". $delay .",\n";
		echo "\"quotesInit\":function(){\n";
		echo "\tif(this.num_quotes>0){\n";
		echo "\tdocument.getElementById('quoterotator').style.opacity=0.0\n";
		echo "\tdocument.getElementById('quoterotator').style.filter=\"alpha(opacity=0.0)\"\n";
		echo "\tnew Effect.Appear('quoterotator',{duration:this.fadeDuration})\n";
		echo "\t\tdocument.getElementById('quoterotator').innerHTML=this.quotes[0]\n";
		echo "\t}\n";
		echo "\telse{\n";
		echo "\t\tdocument.getElementById('quoterotator').innerHTML=\"No Quotes Found!!!\"\n";
		echo "\t}\n";
		echo "\tif(this.num_quotes>1){\n";
		echo "\t\tsetInterval(\"quoteRotator.quoteRotate()\", (this.fadeDuration + this.delay)*1000)\n";
		echo "\t}\n";
		echo "},\n";
		echo "\"quoteRotate\":function(){\n";
		echo "\tdocument.getElementById('quoterotator').style.opacity=0.0\n";
		echo "\tdocument.getElementById('quoterotator').style.filter=\"alpha(opacity=0.0)\"\n";
		echo "\tnew Effect.Appear('quoterotator',{duration:this.fadeDuration})\n";
		echo "\tdocument.getElementById('quoterotator').innerHTML=this.quotes[this.i]\n";
		echo "\tthis.i++\n";
		echo "\tif(this.i==this.num_quotes){\n";
		echo "\t\tthis.i=0\n";
		echo "\t}\n";
		echo "}\n";
		echo "}\n";
		echo "</script>";
	}
		
	function displayWidget($args)
	{
		extract($args);
		
		$options = get_option('widgetQuoteRotator');
		$title = $options['title'];
		$fontsize = $options['fontsize'];
		$fontunit = $options['fontunit'];
		
		echo $before_widget . $before_title . $title . $after_title;
		
		echo "<div id=\"quoterotator\" style=\"font-size:$fontsize$fontunit;\">\n";
		echo "Loading Quotes...\n";
		echo "</div>\n";
		echo "<script type=\"text/javascript\">setTimeout(\"quoteRotator.quotesInit()\", 2000)</script>\n";
		
		echo $after_widget;
	}

	function getQuoteCode($title=null, $delay=null, $fadeDuration=null)
	{
		$output =  "";
           
      if (isset($title) && $title != "") {
   		$output .=  "<h2>" . $title . "</h2>";
		} else {
         $title_from_settings = get_option('fqr_title');
         if (isset($title_from_settings) && $title_from_settings != "") {
      		$output .=  "<h2>" . $title_from_settings . "</h2>";
   		}
      }
		$output .= "<div id=\"quotearea\"><div id=\"quoterotator\">\n";
		$output .= "Loading Quotes...\n";
		$output .= "</div></div>\n";
		$output .= "<script type=\"text/javascript\">";
      if (isset($delay) && $delay != "") {
   		$output .=  "quoteRotator.delay=".$delay.";";
		}
      if (isset($fadeDuration) && $fadeDuration != "") {
   		$output .=  "quoteRotator.fadeDuration=".$fadeDuration.";";
		}
      $output .= "quoteRotator.quotesInit();</script>\n";
		return $output;
	}
}

endif;
?>